// CH372DebugToolDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "CH372DebugTool.h"
#include "CH372DebugToolDlg.h"

#include "CH375DLL.H"
#pragma comment (lib,"CH375DLL")

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//ȫֱ
#define SENDBUFSIZE 4194304 // 4M  4*1024*1024
ULONG mIndex;
HWND WndHandle; //
 // 豸¼֪ͨص
HANDLE DevHandle;
LONGLONG DownCount,UpCount;
VOID CALLBACK CH375NOTIFYROUTINE( ULONG	iEventStatus );  // 豸¼͵ǰ״̬: 0=豸γ¼, 3=豸¼
void EnumCH375Device();

// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CCH372DebugToolDlg Ի




CCH372DebugToolDlg::CCH372DebugToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCH372DebugToolDlg::IDD, pParent)
	, m_downlen(0)
	, m_downdata(_T(""))
	, m_DownInterTime(0)
	, m_uplen(0)
	, m_SaveFileName(_T(""))
	, m_DownRndData(FALSE)
	, m_SaveUpDataToFile(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCH372DebugToolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_DOWNLEN, m_downlen);
	DDX_Text(pDX, IDC_EDIT_DOWNDATA, m_downdata);
	DDX_Text(pDX, IDC_DownInterTime, m_DownInterTime);
	DDV_MinMaxUInt(pDX, m_DownInterTime, 0, 5000);
	DDX_Text(pDX, IDC_EDIT_UPLEN, m_uplen);
	DDX_Text(pDX, IDC_FilePath, m_SaveFileName);
	DDX_Control(pDX, IDC_BUTTON_DOWN, m_btndown);
	DDX_Control(pDX, IDC_BUTTON_UP, m_btnup);
	DDX_Check(pDX, IDC_DownRndData, m_DownRndData);
	DDX_Check(pDX, IDC_AutoSaveToFile, m_SaveUpDataToFile);
	DDX_Control(pDX, IDC_DevicePort, m_cmobo_port);
}

BEGIN_MESSAGE_MAP(CCH372DebugToolDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ClearDownData, &CCH372DebugToolDlg::OnBnClickedCleardowndata)
	ON_BN_CLICKED(IDC_BUTTON_DOWN, &CCH372DebugToolDlg::OnBnClickedButtonDown)
	ON_BN_CLICKED(IDC_ClearUpData, &CCH372DebugToolDlg::OnBnClickedClearupdata)
	ON_BN_CLICKED(IDC_BUTTON_UP, &CCH372DebugToolDlg::OnBnClickedButtonUp)
	ON_BN_CLICKED(IDC_SelectPath, &CCH372DebugToolDlg::OnBnClickedSelectpath)
	ON_BN_CLICKED(IDC_OpenCH375Device, &CCH372DebugToolDlg::OnBnClickedOpench375device)
END_MESSAGE_MAP()


// CCH372DebugToolDlg Ϣ

BOOL CCH372DebugToolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
	LONG i=0;
	char str[3]="";

	for (int i = 1; i < 9; ++i) {
		sprintf(str, "%d", i);
		m_cmobo_port.AddString(str);
	}
	m_cmobo_port.SetCurSel(0);
	memset(str, 0, sizeof(str));
	
	m_trdup = FALSE;
	m_trddown = FALSE;
	m_downdata = _T("");
	m_downlen = 0;
	m_uplen = 4096;
	m_DownInterTime = 100;
	m_open = FALSE;
	m_close = FALSE;

	WndHandle = this->m_hWnd ;
	DownHandle = INVALID_HANDLE_VALUE;    //˵´豸򿪾
	UpHandle = INVALID_HANDLE_VALUE;    //˵ϴ豸򿪾

	for (i=0;i<mCH375_MAX_NUMBER;i++) {//豸(0-15)		
		itoa(i,str,10);
		::SendDlgItemMessage(WndHandle,IDC_DeviceIndex,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)str);				
		if(CH375OpenDevice(i)!=INVALID_HANDLE_VALUE){//ʼʱǷѲCH372/CH375豸
			char tem[50]="";
			::sprintf(tem,"⵽CH372/CH375豸Ѳ.");
			::SetDlgItemText(WndHandle,IDC_DeviceStatus,tem);
			CH375CloseDevice(i);
		}
	}
	::SendDlgItemMessage(WndHandle,IDC_DeviceIndex,CB_SETCURSEL,0,0); //ʼ豸ѡ
	CH375SetDeviceNotify(0,NULL,CH375NOTIFYROUTINE);//ָ豸μ
	DevHandle = INVALID_HANDLE_VALUE; 
	DownCount=0;
	UpCount=0;
	UpdateData(FALSE);

	SendDlgItemMessage(IDC_UPDATABuf, EM_LIMITTEXT, 0xFFFFFFFF, 0);

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CCH372DebugToolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CCH372DebugToolDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CCH372DebugToolDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//˳ر豸̡߳
void CCH372DebugToolDlg::mCloseWin()
{
	m_close = TRUE;
	if(m_open)  // ˳δɵ߳,ر豸
	{
		if(m_trddown)
		{
			CH375AbortWrite(mIndex);
		}
		if(m_trdup)
		{
			CH375AbortRead(mIndex);
		}
		Sleep(50);
		if ( DownHandle != INVALID_HANDLE_VALUE )
		{
			CloseHandle( DownHandle );		//رն˵2´
			DownHandle = INVALID_HANDLE_VALUE;
		}
		if ( UpHandle != INVALID_HANDLE_VALUE )
		{
			CloseHandle( UpHandle );		//رն˵2ϴ
			UpHandle = INVALID_HANDLE_VALUE;
		}	
		CH375CloseDevice(mIndex);
		DevHandle = INVALID_HANDLE_VALUE; 
		m_open=FALSE;
		Sleep(20);
		::SetDlgItemText(WndHandle,IDC_OpenCH375Device,"豸");//Чڵ豸ť
	}
}



void CCH372DebugToolDlg::OnBnClickedCleardowndata()
{
	 //TODO: ڴӿؼ֪ͨ
	{//ۼƼ
		char tem[50]="";
		DownCount=0;
		sprintf(tem,"Down: %d",DownCount);
		::SetDlgItemText(m_hWnd,IDC_DownCount,tem);
	}

	this->m_downdata="";
	UpdateData(FALSE);	
	return;
}

/**************************************************************************/
UCHAR CCH372DebugToolDlg::mCharToBcd(UCHAR iChar)
{
	UCHAR	mBCD;
	if ( iChar >= '0' && iChar <= '9' ) mBCD = iChar -'0';
	else if ( iChar >= 'A' && iChar <= 'F' ) mBCD = iChar - 'A' + 0x0a;
	else if ( iChar >= 'a' && iChar <= 'f' ) mBCD = iChar - 'a' + 0x0a;
//	else mBCD = 0xff;
	else mBCD = 0;
	return( mBCD );
}
/**************************************************************************/
PUCHAR CCH372DebugToolDlg::mStrtoVal(PUCHAR str, ULONG strlen)
{
	ULONG i,j;
	ULONG len;
	//UCHAR strRev[mMAX_BUFFER_LENGTH];
	UCHAR strRev[4096];
	if( strlen % 2 != 0 )
	{
		str[strlen] = 0;
		strlen += 1;
	}
	len = strlen / 2;
	for(i=0,j=0;i<strlen;i++,j++)
	{
		strRev[j] = (UCHAR)((mCharToBcd(str[i])<<4) + mCharToBcd(str[i+1]));
		i++;
	}
	strRev[j]='\0';
	memcpy(  str,strRev,len);
	return str;
}
/************************˵´߳********************************/
UINT mThreadDown(LPVOID pParam)		
{
	ULONG dlen,datalen;
	UCHAR mBuf[mCH375_PACKET_LENGTH*8] = "";
	BOOL AutoDown = FALSE;
	static ULONG RndIndex = 0;
	int PortNum = 0;

	srand((unsigned)time( NULL ));
	CCH372DebugToolDlg *pDlg = (CCH372DebugToolDlg *)pParam;
	pDlg->m_btndown.EnableWindow(FALSE);	
	PortNum = pDlg->m_cmobo_port.GetCurSel() + 1;
	do
	{		
		AutoDown = (IsDlgButtonChecked(pDlg->m_hWnd,IDC_AutoDown) == BST_CHECKED);	
		/**************߳CreateFile豸,ΪÿͬһʱִֻһAPI**************************/		
		if ( pDlg->DownHandle != INVALID_HANDLE_VALUE ) 
		{
			if( pDlg->m_DownRndData )//ʹ´,64ֽ
			{
				UCHAR DLen = 0,i;
				CHAR FmtData[64*3+10] = "";
				
				DLen = rand()%65;
				for(i=0;i<DLen;i++ )
				{
					if(i == 0)
						sprintf(&FmtData[strlen(FmtData)],"%02X ",RndIndex++);
					else
						sprintf(&FmtData[strlen(FmtData)],"%02X ",rand()%255+1);
				}		
				::SetDlgItemText(pDlg->m_hWnd,IDC_EDIT_DOWNDATA,FmtData);
				::SetDlgItemInt(pDlg->m_hWnd,IDC_EDIT_DOWNLEN,DLen,FALSE);
				pDlg->m_downlen = DLen;
			}
			datalen = ::GetWindowTextLength(GetDlgItem(pDlg->m_hWnd,IDC_EDIT_DOWNDATA));
			//datalen = strlen(pDlg->m_downdata2);
			if((LONG)datalen/2 > pDlg->m_downlen)		//ȡݳ볤ƫСֵ
				datalen = pDlg->m_downlen;		
			else{
				datalen = datalen/2;
				pDlg->m_downlen = datalen;
			}			
			//memcpy(mBuf,pDlg->m_downdata2,datalen*2);
			GetDlgItemText(pDlg->m_hWnd,IDC_EDIT_DOWNDATA,(PCHAR)mBuf,sizeof(mBuf));
			pDlg->mStrtoVal(&mBuf[0],datalen*2);
			dlen = datalen;			
			
			//if(!CH375WriteData((ULONG)pDlg->DownHandle,&mBuf[0],&dlen))
			if(!CH375WriteEndP((ULONG)pDlg->DownHandle, PortNum, &mBuf[0], &dlen))
			{
				if ( !pDlg->m_close ) MessageBox(NULL,"˵´ʧܣ豸Ͽôȹرձ","DEBUG372",MB_OK|MB_ICONSTOP);
			}
			else//³ʾ
			{
				char tem[50]="";

				ltoa(dlen,tem,10);
				SetDlgItemText(pDlg->m_hWnd,IDC_EDIT_DOWNLEN,tem);
				
				DownCount=DownCount+dlen;
				sprintf(tem,"Down: %lld",DownCount);
				SetDlgItemText(pDlg->m_hWnd,IDC_DownCount,tem);
			}			
		}
		Sleep(pDlg->m_DownInterTime);
	}while( (pDlg->m_open && pDlg->m_trddown) && AutoDown );
	pDlg->m_trddown = FALSE;
	pDlg->m_btndown.EnableWindow(TRUE);
	return 0;
}

/************************˵ϴ߳********************************/
UINT mThreadUp(LPVOID pParam)		
{
	UCHAR mBuf[mCH375_PACKET_LENGTH*16+2];
	ULONG dlen,datalen,WFLen = 0;	
	BOOL AutoRecv;
	CCH372DebugToolDlg *pDlg = (CCH372DebugToolDlg *)pParam;
	HANDLE FileHandle = INVALID_HANDLE_VALUE;
	SYSTEMTIME SystemTime = {0};
	CHAR SaveFileName[MAX_PATH] = "",TimeFmtStr[128] = "";
	static DWORD iIndex = 0;
	int PortNum = pDlg->m_cmobo_port.GetCurSel() + 1;

	pDlg->m_btnup.EnableWindow(FALSE);

	if(pDlg->m_open && pDlg->m_trdup)		//豸򿪣߳
	{
		if( pDlg->m_SaveUpDataToFile )//ݴļ
		{
			CHAR FmtData[128] = "";

			::GetDlgItemText(pDlg->m_hWnd,IDC_FilePath,SaveFileName,MAX_PATH);
			if( !strlen(SaveFileName) )
			{
				pDlg->MessageBox("USB豸CH372CH375Թ","ָݱļ!",MB_ICONSTOP);
				return 0;
			}
			FileHandle = CreateFile(
				SaveFileName,GENERIC_READ|GENERIC_WRITE,
				FILE_SHARE_WRITE|FILE_SHARE_READ,
				NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
			if( FileHandle == INVALID_HANDLE_VALUE )
			{
				pDlg->MessageBox("ļʧ,رݱļ.","USB豸CH372CH375Թ",MB_ICONSTOP);
				pDlg->m_SaveUpDataToFile = FALSE;
				pDlg->UpdateData(FALSE);
			}
			else
			{
				GetLocalTime(&SystemTime);
				sprintf(FmtData,"\r\n**%04d-%02d-%02d:.(ʱ)():\r\n\0",SystemTime.wYear,SystemTime.wMonth,SystemTime.wDay);
				WFLen = strlen(FmtData);
				::SetFilePointer(FileHandle,NULL,NULL,FILE_END);
				WriteFile(FileHandle,FmtData,WFLen,&WFLen,NULL);
			}
		}
	/**************߳CreateFile豸,ΪÿͬһʱִֻһAPI**************************/
		do{
			AutoRecv = (::IsDlgButtonChecked(pDlg->m_hWnd,IDC_AutoRecv)==BST_CHECKED)?TRUE:FALSE;
			if ( pDlg->UpHandle != INVALID_HANDLE_VALUE ) {  // 豸ɹ						
				datalen = min( pDlg->m_uplen, sizeof(mBuf));
				dlen = datalen;
				//if(CH375ReadData((ULONG)pDlg->UpHandle,&mBuf[0],&dlen) && dlen){//ɹ
				if(CH375ReadEndP((ULONG)pDlg->UpHandle, PortNum, &mBuf[0], &dlen) && dlen){//ɹ
					CHAR buffer[mCH375_PACKET_LENGTH*16*3+10];
					ULONG i,j;
					for(i=0,j=0;i<dlen;i++)
					{
						sprintf(&buffer[j],"%02X ",mBuf[i]);
						j += 3;
					}
					strcat(buffer,"\r\n\0");
					//::SetDlgItemText(pDlg->m_hWnd,IDC_UPDATABuf,buffer); //ʾļ
					SendDlgItemMessage(pDlg->m_hWnd, IDC_UPDATABuf, EM_SETSEL, 0xFFFFFFFE, 0xFFFFFFFE);
					SendDlgItemMessage(pDlg->m_hWnd, IDC_UPDATABuf, EM_REPLACESEL, 0, (LPARAM)buffer);
					SendDlgItemMessage(pDlg->m_hWnd, IDC_UPDATABuf, EM_SETSEL, 0xFFFFFFFE, 0xFFFFFFFE);
					if( pDlg->m_SaveUpDataToFile )//ݴļ
					{
						GetLocalTime(&SystemTime);
						sprintf(TimeFmtStr,"%08d.(%02d:%02d:%02d:%03d)(%04d B):",
							++iIndex,
							SystemTime.wHour,SystemTime.wMinute,SystemTime.wSecond,SystemTime.wMilliseconds,
							dlen);
						WFLen = strlen(TimeFmtStr);
						::SetFilePointer(FileHandle,NULL,NULL,FILE_END);
						WriteFile(FileHandle,TimeFmtStr,WFLen,&WFLen,NULL);
						WFLen = strlen(buffer);
						::SetFilePointer(FileHandle,NULL,NULL,FILE_END);
						if( !WriteFile(FileHandle,buffer,WFLen,&WFLen,NULL) )//ʧ
						{
							pDlg->MessageBox("ļʧ,رݱļ.","USB豸CH372CH375Թ",MB_ICONSTOP);
							pDlg->m_SaveUpDataToFile = FALSE;
							pDlg->UpdateData(FALSE);
						}
					}
					//strcat(buffer,"\r\n\0");
					//j+=2;
					//ShowUpdata(buffer,j); //ʾ					
					{//³ʾ
						char tem[50]="";
						
						UpCount=UpCount+dlen;
						sprintf(tem,"Up: %lld",UpCount);
						SetDlgItemText(pDlg->m_hWnd,IDC_UpCount,tem);
					}					
				}
				else if ( !pDlg->m_close ) {
					MessageBox(NULL,"˵ϴʧܣ豸Ͽôȹرձ","DEBUG372",MB_OK|MB_ICONSTOP);
					break;
				}
			}
		}while( pDlg->m_open && pDlg->m_trdup && AutoRecv);
	}
	{
		strcpy(TimeFmtStr,"**");
		WFLen = strlen(TimeFmtStr);
		::SetFilePointer(FileHandle,NULL,NULL,FILE_END);
		WriteFile(FileHandle,TimeFmtStr,WFLen,&WFLen,NULL);
	}
	if(FileHandle != INVALID_HANDLE_VALUE)
		CloseHandle(FileHandle);
	pDlg->m_trdup = FALSE;
	pDlg->m_btnup.EnableWindow(TRUE);
	//ExitThread(0);	
	return 0;
}

void CCH372DebugToolDlg::OnBnClickedButtonDown()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData(TRUE);
	CWinThread * mTrdDown = NULL;
	if(!m_open)	{
		MessageBox("ȴ豸!","DEBUG372",MB_OK|MB_ICONSTOP);
		return;			
	}
	if(DownHandle == INVALID_HANDLE_VALUE)
	{
		UCHAR DeviceName[128];
		memcpy(&DeviceName[0],CH375GetDeviceName(mIndex),sizeof(DeviceName));
		DownHandle = CreateFile( (char *)&DeviceName[0], GENERIC_READ | GENERIC_WRITE,  // 豸
										FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
		if(DownHandle == INVALID_HANDLE_VALUE)
		{
			MessageBox("޷豸","DEBUG372",MB_OK|MB_ICONSTOP);
			return;
		}
	}	
	if( (m_downlen == 0 || m_uplen > mCH375_PACKET_LENGTH*64+2 ) && (!this->m_DownRndData) )
	{
		MessageBox("´ݳȣ","DEBUG372",MB_OK);
		return;
	}
	//߳̾Ч,˵ϴ߳˳
	if(mTrdDown != INVALID_HANDLE_VALUE){
		CloseHandle(mTrdDown); //ͷ߳̾
		mTrdDown = NULL;
	}
    //߳
	mTrdDown = AfxBeginThread(mThreadDown,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
	if(mTrdDown)
	{
		m_trddown = TRUE;		//߳־
	}
	else
	{
		MessageBox("˵´߳ʧ","DEBUG372",MB_OK|MB_ICONSTOP);
		m_trddown = FALSE;
		return;
	}
}

void CCH372DebugToolDlg::OnBnClickedClearupdata()
{
	// TODO: ڴӿؼ֪ͨ
	{//ۼƼ
		char tem[50]="";
		UpCount=0;
		sprintf(tem,"Up: %d",UpCount);
		::SetDlgItemText(m_hWnd,IDC_UpCount,tem);
	}

	::SetDlgItemText(WndHandle,IDC_UPDATABuf,"");	
	return;
}

void CCH372DebugToolDlg::OnBnClickedButtonUp()
{
	// TODO: ڴӿؼ֪ͨ
	CWinThread * mTrdUp = NULL;
	UpdateData(TRUE);
	if(!m_open)	{
		MessageBox("ȴ豸!","DEBUG372",MB_OK|MB_ICONSTOP);
		return;			
	}
	if(UpHandle == INVALID_HANDLE_VALUE)
	{
		UCHAR DeviceName[128];
		memcpy(&DeviceName[0],CH375GetDeviceName(mIndex),sizeof(DeviceName));
		UpHandle = CreateFile( (char *)&DeviceName[0], GENERIC_READ | GENERIC_WRITE,  // 豸
									FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
		if(UpHandle == INVALID_HANDLE_VALUE)
		{
			MessageBox("޷豸","DEBUG372",MB_OK|MB_ICONSTOP);
			return;
		}
	}
	if(m_uplen == 0 || m_uplen > mCH375_PACKET_LENGTH*64+2 )
	{
		MessageBox("ϴȣ","DEBUG372",MB_OK);
		return;
	}
	//߳̾Ч,˵ϴ߳Ȼ˳
	if(mTrdUp != INVALID_HANDLE_VALUE){
		CloseHandle(mTrdUp); //ͷ߳̾
		mTrdUp = NULL;
	}
    //ϴ߳
	mTrdUp = AfxBeginThread(mThreadUp,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
	if(mTrdUp)
	{
		m_trdup = TRUE;		//߳־
	}
	else
	{
		MessageBox("˵ϴ߳ʧ","DEBUG372",MB_OK|MB_ICONSTOP);
		m_trdup = FALSE;
		return;
	}
	Sleep(10);
	UpdateData(FALSE);
}

void CCH372DebugToolDlg::OnBnClickedSelectpath()
{
	// TODO: ڴӿؼ֪ͨ
	OPENFILENAME ofn={0};
	CHAR SaveFileName[MAX_PATH]="";
				
	ZeroMemory(&ofn, sizeof(OPENFILENAME)); 
	ofn.lStructSize = sizeof(OPENFILENAME); 
	ofn.hwndOwner = m_hWnd; 
	ofn.lpstrFile = SaveFileName; 
	ofn.nMaxFile = MAX_PATH;	
				
	ofn.lpstrFilter = "*.log\0"; 
	ofn.lpstrDefExt = "log";			
	GetSaveFileName(&ofn);
	::SetDlgItemText(m_hWnd,IDC_FilePath,SaveFileName);	
	return;
}

/* 豸¼֪ͨص,ڴ˳ﲻĲ,ҪΪжϷȼ,
	˽USB䣬ֻͨǷϢøȫֱ֪ͨ*/
VOID CALLBACK CH375NOTIFYROUTINE( 
	        	ULONG iEventStatus ){  //豸¼͵ǰ״̬: 0=豸γ¼, 3=豸¼	
	char tem[100]="";
	if(iEventStatus==CH375_DEVICE_ARRIVAL){ //⵽豸¼
		::sprintf(tem," ⵽CH372/CH375豸Ѳ.");
		::SetDlgItemText(WndHandle,IDC_DeviceStatus,tem);//Чڵ豸ť
	}
	else if(iEventStatus==CH375_DEVICE_REMOVE){//⵽豸γ¼
		::sprintf(tem," ⵽CH372/CH375豸Ѱγ.");		
		::SetDlgItemText(WndHandle,IDC_DeviceStatus,tem);//Чڵ豸ť		
		if(DevHandle != INVALID_HANDLE_VALUE)
			::SendDlgItemMessage(WndHandle,IDC_OpenCH375Device,BM_CLICK,0,0);//Чڵ豸ť			
	}
	return;
}

//豸
void CCH372DebugToolDlg::OnBnClickedOpench375device()
{
	// TODO: ڴӿؼ֪ͨ
	char WndTitle[50]="";
	ULONG DeviceID=0;
	if (m_open) { //豸ѱ,ȹر		
		mCloseWin();
		sprintf(WndTitle," ID:%04X,豸ID:%04X",0,0);
		::SetDlgItemText(WndHandle,IDC_DeviceInfor,WndTitle);
		m_open=FALSE;
	} else {
		mIndex = ::SendDlgItemMessage(WndHandle,IDC_DeviceIndex,CB_GETCURSEL,0,0);
		// ʹ֮ǰ豸
		DevHandle = CH375OpenDevice( mIndex ) ;
		if (DevHandle == INVALID_HANDLE_VALUE ) {  		
			m_open = FALSE;
			sprintf(WndTitle,"%d#豸ʧ!",mIndex);
			MessageBox(WndTitle,"USBDEBUG",MB_OK|MB_ICONSTOP);		
			return;
		}
		m_open = TRUE;
		DeviceID = CH375GetUsbID(mIndex); //ȡǰ򿪵USB豸ID,,16λΪID,16λΪƷID,ʱȫ0(ЧID)
		sprintf(WndTitle," ID:%04X,豸ID:%04X",LOWORD(DeviceID),HIWORD(DeviceID));
		::SetDlgItemText(WndHandle,IDC_DeviceInfor,WndTitle);
		sprintf(WndTitle,"ر%d#豸",mIndex);
		::SetDlgItemText(WndHandle,IDC_OpenCH375Device,WndTitle);		
	}
	return;
}
